with(linalg):readlib(trace): with(combinat):with(Groebner):

checkhom := proc(f::polynom, var::list, d::name)
local td, T, ii;
  if not type(f, polynom(anything, var)) then
  ERROR("Wrong type of input");
  fi;
  coeffs(f, var, 'T');
  T := [T];
  td := degree(T[1], var);
  for ii from 2 to nops(T) do
  if td <> degree(T[ii], var) then RETURN(false) fi
  od;
  d := td;
  RETURN(true);
  end:
 
 monomials := proc(nu, var::list)
 local CC;
  if nu<=0 then RETURN([]) fi;
  CC := choose(nops(var)+nu-1, nu);
  RETURN(map(proc(XX)
 local ii, ind, tt;
  ind := XX[1];
  tt := var[ind];
  for ii from 1 to nu-1 do
ind := ind + XX[ii+1]-XX[ii]-1;
 tt := tt*var[ind]
 od;
 RETURN(tt);
 end, CC))
 end:

 orderarray := proc(Y::list, Z::matrix)
 local u,v, n, m, i, j;
 n := nops(Y);
 m := rowdim(Z);
 u := col(Z,1);
 v := vector(n);
 for i from 1 to n do
 v[i] := 0;
 for j from 1 to m do
 if u[j] = Y[i] then v[i] := Z[j,2]; break
 fi
 od
 od;
 RETURN(evalm(v))
 end:

 Macaulay2 := proc(F::list,var::list)
 local n, deglist, nu, MON, mon, ii, MONi, CF, MM; 
   n := nops(var);
   map(proc(XX) if not type(XX,polynom(anything, var)) then
     ERROR("Wrong type of input") fi; end, F);
   deglist := map(proc(XX) if not checkhom(XX, var, 'dg' ) then
     ERROR("Input polynomials are not homogeneous") fi;
   dg; end, F);
   if n <> nops(F) then ERROR("Wrong number of polynomials") fi;
   nu := `+`(op(deglist))-n+1;
   MON := monomials(nu, var);
   MM := matrix(nops(MON),1, MON);
   for ii from 1 to n do
     MONi := monomials(nu-deglist[ii], var);
     for mon in MONi do
       CF:= [coeffs(expand(mon*F[ii]), convert(var,set), 'T')];
       CF:= augment([T],CF);
       MM := concat( MM , orderarray(MON, CF))
     od;
   od;
   MM := delcols( MM, 1..1);
 RETURN(evalm(MM),MON);
 end:


 Chardin := proc(F::list,var::list, nu::nonnegint)
 local n, deglist, flag, jj, MON, mon, ii, MONi, CF, MM, VV,WW;
 n := nops(var);
 map(proc(XX) if not type(XX,polynom(anything, var)) then
 ERROR("Wrong type of input") fi; end, F);
 deglist := map(proc(XX) if not checkhom(XX, var, 'dg' ) then
 ERROR("Input polynomials are not homogeneous") fi;
 dg; end, F);
 if n <> nops(F) then ERROR("Wrong number of polynomials") fi;
 WW := matrix(1,0,[]);
 
 MON := monomials(nu, var);
 MM := matrix(nops(MON),1, MON);
 if nops(MON)<>0 then
 for mon in MON do
 for jj from 1 to n do
 if degree(mon, var[jj])>=deglist[jj] then
 WW := augment(WW, matrix(1,1, [mon]));
 CF := [coeffs(expand(mon*F[jj]/var[jj]^deglist[jj]), convert(var,set),'T')];
 CF:= augment([T],CF);
 MM := concat( MM , orderarray(MON, CF));
 break;
 fi;
 od;
 od;
 fi;
 VV := submatrix(MM, 1..rowdim(MM),1..1);
 MM := delcols( MM, 1..1);
 RETURN(evalm(MM), evalm(VV), evalm(WW));
 end:

 Mbezout := proc(var::list,F::list,var2::list)
 local n, X, y, P, MM, i, j,T1, T2, C1, C, DP;
 n := nops(var);
 P := matrix(n+1, n+1);
 if n <> nops(F)-1 then ERROR("Wrong number of polynomials") fi;
 X[0] := {};
 for i from 1 to n do
 X[i] := X[i-1] union {var[i]=var2[i]};
 for j from 1 to n+1 do
 P[i,j] := simplify((subs(X[i], F[j])-subs(X[i-1], F[j]))/(var2[i]-var[i]))
 od;
 od;
 for j from 1 to n+1 do
 P[n+1,j] := F[j]
 od;
 DP := det(P);
 C1 := [coeffs(DP, convert(var, set), 'T1')];
 T1 := [T1];
 T2 := {};
 for i from 1 to nops(T1) do
 C[i]:= [coeffs(C1[i], convert(var2,set), 'T')];
 C[i] := augment([T],C[i]);
 T2 := T2 union {T}
 od;
 T2 := [op(T2)];
 MM := orderarray(T2, C[1]);
 for i from 2 to nops(T1) do
 MM := concat( MM , orderarray(T2, C[i]))
 od;
 RETURN( evalm(MM),T1, T2);
 end:
 

